// TableCalc_EvalExpr.c -*- c++ -*- Time-stamp: <2008/03/24>
// by HAL 2005-2008 <http://hal9.blog3.fc2.com> HAL.Kinosita@gmail.com

// vZ]Č double ԂBPCalc/EvalExpr.c 
// ɕϐԂ̈ˑ֌WԂB

// GPL ɊÂC̃\[XR[h̎gpCρCĔzz͎RłB

#include <string.h>
#include <PalmOS.h>

#include "MathLib.h"
#include "TableCalc.h"

//#include "EvalExpr.h"
//#include "ConvStrToDbl.h"


// defines. 
#define UseBinNum 1
#define EvalVarAsExprs 0
#define NESTMAX	60 //80 //40 // ɍċAIɌĂяo֐QX^bNTCYɈˑČ܂B
//                           // 4k ̃X^bN exprs, nest O[oԂł͍ċA̐[̌E 70 炢ɂĂvB
//                           //  pos O[o  80 炢łvH
//                           // iTableCalc_Form.c ňˑ֌ŴɊ֐ċAIɎĝ 80 ł͑傫j
//                           //  EvalVarAsExprs 1 ̏ꍇ
//                           // EvalVarAsExprs  0 ɂĂ΂Ƒ傫ȒlɂĂvȂ͂
#define PI	3.14159265358979323846

// Ǝ֐̐錾C`
double if3(double condition, double ifTrue, double ifFalse){ return ( (Boolean)condition ? ifTrue : ifFalse ); }
double isinfF( double x){ return (double)isinf( x); }
double finiteF(double x){ return (double)finite(x); }

// R֐ꗗ
const Func3ArgInfo_t func3Lst[] = {
	{"if"   , if3  , FT_NORM },
	{""     , NULL , FT_EOL  } //terminator
};

// Q֐ꗗ
const Func2ArgInfo_t func2Lst[] = {
	{"atan2", atan2, FT_DivAU},
	{"hypot", hypot, FT_NORM },
	{"pow"  , pow  , FT_NORM },
	{""     , NULL , FT_EOL  } //terminator
};

// P֐ꗗ
const Func1ArgInfo_t func1Lst[] = {
  {"sqrt"  , sqrt   , FT_NORM },
	{"cbrt"  , cbrt   , FT_NORM }, //Cube root of x	[x**(1/3)]
	{"log"   , log10  , FT_NORM },
	{"ln"    , log    , FT_NORM },
	{"abs"   , fabs   , FT_NORM },
	{"exp"   , exp    , FT_NORM },
	{"sin"   , sin    , FT_MulAU},
	{"cos"   , cos    , FT_MulAU},
	{"tan"   , tan    , FT_MulAU},
	{"asin"  , asin   , FT_DivAU},
	{"acos"  , acos   , FT_DivAU},
	{"atan"  , atan   , FT_DivAU},
	{"sinh"  , sinh   , FT_NORM },
	{"cosh"  , cosh   , FT_NORM },
	{"tanh"  , tanh   , FT_NORM },
	{"asinh" , asinh  , FT_NORM },
	{"acosh" , acosh  , FT_NORM },
	{"atanh" , atanh  , FT_NORM },
	{"ceil"  , ceil   , FT_NORM },
	{"floor" , floor  , FT_NORM },
	{"round" , round  , FT_NORM },
	{"rint"  , rint   , FT_NORM },
	//{"finite", finiteF, FT_NORM },
	{"isinf" , isinfF , FT_NORM },
	{""      , NULL   , FT_EOL  } //terminator
};


// global variables 
static double        g_AngleUnit = PI / 180.;

static unsigned int  g_Nest  = 0   ; // X^bNI[o[t[̂߂
static char*         g_Exprs = NULL; // O[oϐ
static unsigned int  g_Pos   = 0   ; //

static Boolean     *gP_dependsOn = NULL; // TableCalc {̂Ƃ̏
static int          g_ExprNo  = -1  ;    // 󂯓n̊ȕ։̂߂̃O[oϐ


// prototypes 
static ExprEvalErr_t       addsub(double* x) MSEG3; // ̊֐͖{ char *expr, unsigned int nest, unsigned int *ppos,
static ExprEvalErr_t       muldiv(double* x) MSEG3; // ɎB
static ExprEvalErr_t        power(double* x) MSEG3; // ͍ċAIɌĂяoB
static ExprEvalErr_t         sign(double* x) MSEG3; // ]đ̈邱Ƃő̃X^bNB
static ExprEvalErr_t        afunc(double* x) MSEG3; // X^bNI[o[t[NȂ߂
//static ExprEvalErr_t      paren(double* x) MSEG3; // ̈O[oϐƂB
static ExprEvalErr_t       number(double* x) MSEG3; // 
static Boolean      ConvStrToUInt(double* x) MSEG3;
static ExprEvalErr_t ConvStrToDbl(double* x) MSEG3; // \̂̃|C^nłǂ
																	 	 				 
static ExprEvalErr_t   varInTable(double* x) MSEG3;
static ExprEvalErr_t  l_EvalExprs(char* exprs, double* x) MSEG3;
																		 				 
//static int               compword(char* wordA, char* wordB, unsigned int cPosA);


static inline void chopspace(void)  MSEG3;
static inline void chopspace(void){ 
	while( g_Exprs[g_Pos] == ' ' || g_Exprs[g_Pos] == '\t' ) g_Pos++;
  return;
}

/*
static void chkStack(void){
	MemPtr pBgn, pEnd;
	if( !SysGetStackInfo(&pBgn, &pEnd) )
		SysFatalAlert("EvalExprs Stack Overflow");
}
*/

void setDeg(void){
  g_AngleUnit = PI / 180.;
}

void setRad(void){
  g_AngleUnit = 1.;
}

static ExprEvalErr_t addsub(double* x){
  double y;
  ExprEvalErr_t evlErr;

	//chkStack();
  g_Nest++;  if (g_Nest >= NESTMAX) return EE_DEEP_NESTING;


  chopspace();
  evlErr = muldiv(x);  if(evlErr != EE_NONE) return evlErr;

  for(;;){

    chopspace();
    if(g_Exprs[g_Pos] == '+'){
      g_Pos++; 
      evlErr = muldiv(&y); if(evlErr != EE_NONE) return evlErr;
      *x = *x + y;
    }
		else if (g_Exprs[g_Pos] == '-'){
      g_Pos++;              
      evlErr = muldiv(&y); if(evlErr != EE_NONE) return evlErr;
      *x = *x - y;
		}
#if UseBinNum // rbgρCa // Zq̗D揇ʂƂĂ炪̈ʒuł̂H
		else if(g_Exprs[g_Pos] == '&'){
			g_Pos++;                 
      evlErr = muldiv(&y); if(evlErr != EE_NONE) return evlErr;
      *x = (double)((unsigned long long)(*x) & (unsigned long long)(y));
    } 
		else if(g_Exprs[g_Pos] == '|'){
			g_Pos++;                 
      evlErr = muldiv(&y); if(evlErr != EE_NONE) return evlErr;
      *x = (double)((unsigned long long)(*x) | (unsigned long long)(y));
    } 
#endif
    else
      break;
		
  } //for(;;)


  g_Nest--;
  return EE_NONE;
}


static ExprEvalErr_t muldiv(double* x){
  double y;
  ExprEvalErr_t evlErr;

	//chkStack();
  g_Nest++; if(g_Nest >= NESTMAX) return EE_DEEP_NESTING;


  chopspace();
  evlErr = sign(x); if(evlErr != EE_NONE) return evlErr;

  for(;;){
		
    chopspace();
    if(g_Exprs[g_Pos] == '*'){
			g_Pos++;           
      evlErr = sign(&y); if(evlErr != EE_NONE) return evlErr;
      *x = *x * y;
    } 
		else if(g_Exprs[g_Pos] == '/'){
			g_Pos++;                 
      evlErr = sign(&y); if(evlErr != EE_NONE) return evlErr;
      *x = *x / y;
    } 
#if UseBinNum // Z̗]CrbgVtg //Zq̗D揇ʂƂĂ炪̈ʒuł̂H  <<  >>
		else if(g_Exprs[g_Pos] == '%'){
			g_Pos++;                 
      evlErr = sign(&y); if(evlErr != EE_NONE) return evlErr;
			//if( (long long)(y) == 0 ) return EE_DivByZero; 
			//*x = (double)((long long)(*x) % (long long)(y));
			*x = fmod(*x, y);
    } 
		else if(g_Exprs[g_Pos] == '>' && g_Exprs[g_Pos+1] == '>' ){
			g_Pos += 2;                 
      evlErr = sign(&y); if(evlErr != EE_NONE) return evlErr;
      *x = (double)((unsigned long long)(*x) >> (unsigned long long)(y));
    } 
		else if(g_Exprs[g_Pos] == '<' && g_Exprs[g_Pos+1] == '<' ){
			g_Pos += 2;                 
      evlErr = sign(&y); if(evlErr != EE_NONE) return evlErr;
      *x = (double)((unsigned long long)(*x) << (unsigned long long)(y));
    } 
		// ֌WZq
		else if(g_Exprs[g_Pos] == '=' && g_Exprs[g_Pos+1] == '=' ){
			g_Pos += 2;                 
      evlErr = sign(&y); if(evlErr != EE_NONE) return evlErr;
      *x = (double)((*x) == (y));
    } 
		else if(g_Exprs[g_Pos] == '!' && g_Exprs[g_Pos+1] == '=' ){
			g_Pos += 2;                 
      evlErr = sign(&y); if(evlErr != EE_NONE) return evlErr;
      *x = (double)((*x) != (y));
    } 
		else if((g_Exprs[g_Pos] == '<' && g_Exprs[g_Pos+1] == '=' ) || 
						(g_Exprs[g_Pos] == '=' && g_Exprs[g_Pos+1] == '<' )){
			g_Pos += 2;                 
      evlErr = sign(&y); if(evlErr != EE_NONE) return evlErr;
      *x = (double)((*x) <= (y));
    } 
		else if((g_Exprs[g_Pos] == '>' && g_Exprs[g_Pos+1] == '=' ) || 
						(g_Exprs[g_Pos] == '=' && g_Exprs[g_Pos+1] == '>' )){
			g_Pos += 2;                 
      evlErr = sign(&y); if(evlErr != EE_NONE) return evlErr;
      *x = (double)((*x) >= (y));
    } 
		else if(g_Exprs[g_Pos] == '<'){
			g_Pos += 1;                 
      evlErr = sign(&y); if(evlErr != EE_NONE) return evlErr;
      *x = (double)((*x) < (y));
    } 
		else if(g_Exprs[g_Pos] == '>'){
			g_Pos += 1;                 
      evlErr = sign(&y); if(evlErr != EE_NONE) return evlErr;
      *x = (double)((*x) > (y));
    } 
#endif
#if 1 // ֐ϐCʂ̒ȌꍇCȗꂽ '*' ⊮B a=3 ̎ 10*a = 30 łȂ 10a = 30 ̕]s
		// paren() ł肱łق悳B
		// "log 10 (10) = 2" łȂ"log 10 (10) = 10" ܂ "log(10) *10 = 10" Ɖ߂ "log(10 *10) = 2" Ƃ͂ȂȂ
		else if(   (g_Exprs[g_Pos] >= 'a' && g_Exprs[g_Pos] <= 'z')
						|| (g_Exprs[g_Pos] >= 'A' && g_Exprs[g_Pos] <= 'Z')
						|| (g_Exprs[g_Pos] == '_'                         )
						|| (g_Exprs[g_Pos] == '('                         )
					 ){
			double y;
			//evlErr = afunc(&y); if(evlErr != EE_NONE) return evlErr;
			evlErr = power(&y); if(evlErr != EE_NONE) return evlErr;
			*x *= y;
		}
#endif
		else
      break;

  } // for(;;)
	

  g_Nest--;
  return EE_NONE;
}


static ExprEvalErr_t sign(double* x){
  double y;
  ExprEvalErr_t evlErr;

	//chkStack();
  g_Nest++;  if(g_Nest >= NESTMAX) return EE_DEEP_NESTING;


  chopspace();

  if(g_Exprs[g_Pos] == '+'){
    g_Pos++;             
    evlErr = power(&y); if(evlErr != EE_NONE) return evlErr;
    *x = +y;
  }
	else if(g_Exprs[g_Pos] == '-'){
    g_Pos++;             
    evlErr = power(&y); if(evlErr != EE_NONE) return evlErr;
    *x = -y;
  }
#if UseBinNum // rbg]
	else if(g_Exprs[g_Pos] == '~'){
    g_Pos++;             
    evlErr = power(&y); if(evlErr != EE_NONE) return evlErr;
    //*x = (double)(       ~((long long)(y)) );
    //*x = (double)( 0xFFFF^((long long)(y)) );
		{
			unsigned long long full = 0xF;
			//while((unsigned long long)(y) > full) full = full *  2 +   1;
			while((unsigned long long)(y) > full) full = full * 16 + 0xF;
			*x = (double)( full ^ ((unsigned long long)(y)) );
		}
  }
	// _ے
	else if(g_Exprs[g_Pos] == '!'){
    g_Pos++;             
    evlErr = power(&y); if(evlErr != EE_NONE) return evlErr;
		*x = !(Boolean)y;
  }
#endif
	else{
    evlErr = power( x); if(evlErr != EE_NONE) return evlErr;
  }


  g_Nest--;
  return EE_NONE;
}


static ExprEvalErr_t power(double* x){
  double y;
  ExprEvalErr_t evlErr;

	//chkStack();
  g_Nest++;  if (g_Nest >= NESTMAX) return EE_DEEP_NESTING;


  chopspace();
  evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;

  chopspace();
  if(g_Exprs[g_Pos] == '^'){
    g_Pos++;          
    evlErr = power(&y); if(evlErr != EE_NONE) return evlErr;
    *x = pow(*x, y);
  }


  g_Nest--;
  return EE_NONE;
}


static ExprEvalErr_t afunc(double* x){
  ExprEvalErr_t evlErr = EE_NotEval;
	unsigned int c3Func = 0,  c2Func = 0, c1Func = 0;

	//chkStack();
  g_Nest++;  if (g_Nest >= NESTMAX) return EE_DEEP_NESTING;


  chopspace();
	
	// R֐Ƃ̈v
	for(c3Func = 0; StrLen(func3Lst[c3Func].name) > 0 && func3Lst[c3Func].pfunc != NULL; c3Func++)
		if(compword(g_Exprs, (char*)func3Lst[c3Func].name, g_Pos))
			break;

	if(StrLen(func3Lst[c3Func].name) == 0 || func3Lst[c3Func].pfunc == NULL){
		// Q֐Ƃ̈v
		for(c2Func = 0; StrLen(func2Lst[c2Func].name) > 0 && func2Lst[c2Func].pfunc != NULL; c2Func++)
			if(compword(g_Exprs, (char*)func2Lst[c2Func].name, g_Pos))
				break;
		
		if(StrLen(func2Lst[c2Func].name) == 0 || func2Lst[c2Func].pfunc == NULL){
			// P֐Ƃ̈v
			for(c1Func = 0; StrLen(func1Lst[c1Func].name) > 0 && func1Lst[c1Func].pfunc != NULL; c1Func++)
				if(compword(g_Exprs, (char*)func1Lst[c1Func].name, g_Pos))
					break;
		}
	}
	
	// R֐Ƃ̈v̏ꍇ
	if(     StrLen(func3Lst[c3Func].name) > 0 && func3Lst[c3Func].pfunc != NULL){
		double y, z;
		g_Pos += StrLen(func3Lst[c3Func].name); 

		chopspace(); if(g_Exprs[g_Pos] != '(') return EE_SyntaxErr; //R֐ł̓JbR͕K{Ƃ
		g_Pos++; 

		evlErr = addsub(x); if(evlErr != EE_NONE) return evlErr;    //JbR͏ςȂ̂paren()̏Ɠ悤addsub()Ă
		
		chopspace(); if(g_Exprs[g_Pos] != ',') return EE_SyntaxErr;
		g_Pos++; 

		evlErr = addsub(&y); if(evlErr != EE_NONE) return evlErr;

		chopspace(); if(g_Exprs[g_Pos] != ',') return EE_SyntaxErr;
		g_Pos++; 

		evlErr = addsub(&z); if(evlErr != EE_NONE) return evlErr;

		chopspace(); if(g_Exprs[g_Pos] != ')') return EE_SyntaxErr;
		g_Pos++;

		if(     func3Lst[c3Func].funcType == FT_DivAU) *x = (*(func3Lst[c3Func].pfunc))( *x , y , z ) / g_AngleUnit;
		else if(func3Lst[c3Func].funcType == FT_MulAU) *x = (*(func3Lst[c3Func].pfunc))( *x * g_AngleUnit, 
																																										  y * g_AngleUnit, 
																																										  z * g_AngleUnit );
		else                                           *x = (*(func3Lst[c3Func].pfunc))( *x , y , z );
	}
	// Q֐Ƃ̈v̏ꍇ
	else if(StrLen(func2Lst[c2Func].name) > 0 && func2Lst[c2Func].pfunc != NULL){
		double y;
		g_Pos += StrLen(func2Lst[c2Func].name); 

		chopspace(); if(g_Exprs[g_Pos] != '(') return EE_SyntaxErr; //Q֐ł̓JbR͕K{Ƃ
		g_Pos++; 

		evlErr = addsub(x); if(evlErr != EE_NONE) return evlErr;    //JbR͏ςȂ̂paren()̏Ɠ悤addsub()Ă
		
		chopspace(); if(g_Exprs[g_Pos] != ',') return EE_SyntaxErr;
		g_Pos++; 

		evlErr = addsub(&y); if(evlErr != EE_NONE) return evlErr;

		chopspace(); if(g_Exprs[g_Pos] != ')') return EE_SyntaxErr;
		g_Pos++;

		if(     func2Lst[c2Func].funcType == FT_DivAU) *x = (*(func2Lst[c2Func].pfunc))( *x , y ) / g_AngleUnit;
		else if(func2Lst[c2Func].funcType == FT_MulAU) *x = (*(func2Lst[c2Func].pfunc))( *x * g_AngleUnit, 
																																										  y * g_AngleUnit  );
		else                                           *x = (*(func2Lst[c2Func].pfunc))( *x , y );
	}
	// P֐Ƃ̈v̏ꍇ //iڂ͂Ƃje͌\[X(PCalc)̂܂
	else if(StrLen(func1Lst[c1Func].name) > 0 && func1Lst[c1Func].pfunc != NULL){
		g_Pos += StrLen(func1Lst[c1Func].name); 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
		if(     func1Lst[c1Func].funcType == FT_DivAU) *x = (*(func1Lst[c1Func].pfunc))(*x) / g_AngleUnit   ;
		else if(func1Lst[c1Func].funcType == FT_MulAU) *x = (*(func1Lst[c1Func].pfunc))(*x  * g_AngleUnit  );
		else                                           *x = (*(func1Lst[c1Func].pfunc))(*x)                 ;
	}
	/*
  if(compword(g_Exprs, "sqrt", g_Pos)){
    g_Pos += 4; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = sqrt(*x);
  }
  else if(compword(g_Exprs, "log", g_Pos)){
    g_Pos += 3;
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = log10(*x);
  }
  else if(compword(g_Exprs, "ln", g_Pos)){
    g_Pos += 2;
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = log(*x);
  }
  else if(compword(g_Exprs, "exp", g_Pos)){
    g_Pos += 3;
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = exp(*x);
  }
  else if(compword(g_Exprs, "asinh", g_Pos)){
		g_Pos += 5; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = asinh(*x);
  }
  else if(compword(g_Exprs, "acosh", g_Pos)){
		g_Pos += 5; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = acosh(*x);
  }
  else if(compword(g_Exprs, "atanh", g_Pos)){
    g_Pos += 5; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = atanh(*x);
  }
  else if(compword(g_Exprs, "sinh", g_Pos)){
    g_Pos += 4; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = sinh(*x);
  }
  else if(compword(g_Exprs, "cosh", g_Pos)){
    g_Pos += 4; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = cosh(*x);
  }
  else if(compword(g_Exprs, "tanh", g_Pos)){
    g_Pos += 4;
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = tanh(*x);
  }
  else if(compword(g_Exprs, "asin", g_Pos)){
    g_Pos += 4; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = asin(*x) / g_AngleUnit;
  }
  else if(compword(g_Exprs, "acos", g_Pos)){
    g_Pos += 4; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = acos(*x) / g_AngleUnit;
  }
  else if(compword(g_Exprs, "atan", g_Pos)){
    g_Pos += 4; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = atan(*x) / g_AngleUnit;
  }
  else if(compword(g_Exprs, "sin", g_Pos)){
    g_Pos += 3; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = sin(*x * g_AngleUnit);
  }
  else if(compword(g_Exprs, "cos", g_Pos)){
    g_Pos += 3; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = cos(*x * g_AngleUnit);
  }
  else if(compword(g_Exprs, "tan", g_Pos)){
    g_Pos += 3;
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = tan(*x * g_AngleUnit);
  }
  else if(compword(g_Exprs, "ceil", g_Pos)){
    g_Pos += 4; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = ceil(*x);
  }
  else if(compword(g_Exprs, "floor", g_Pos)){
    g_Pos += 5; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = floor(*x);
  }
  else if(compword(g_Exprs, "abs", g_Pos)){
    g_Pos += 3; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = fabs(*x);
  }
  else if(compword(g_Exprs, "rint", g_Pos)){
    g_Pos += 4; 
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = rint(*x);
  }

	else if(compword(g_Exprs, "round", g_Pos)){ // Added by HAL
    g_Pos += 5;
    evlErr = afunc(x); if(evlErr != EE_NONE) return evlErr;
    *x = round(*x);
  }
	*/
	// Stack Over Flow 邽߁Cparen() ֐ƂČĂяoCȉɒڋLq
  //else {
  //  evlErr = paren(x); if(evlErr != EE_NONE) return evlErr;
  //}
	//  paren()
	else if(g_Exprs[g_Pos] == '('){
		g_Pos++;            
		evlErr = addsub(x); if(evlErr != EE_NONE) return evlErr;
		
		chopspace();
		if(g_Exprs[g_Pos] != ')') return EE_PAREN_NOT_MATCH; 
		g_Pos++; 
	} 

	chopspace();
	if(evlErr == EE_NotEval && g_Exprs[g_Pos] == '\0') return EE_NULL_FOUND;

	if(evlErr != EE_NONE){
		chopspace(); if(g_Exprs[g_Pos] == '\0') return evlErr;
		evlErr = number(x); 
	}

	if(evlErr != EE_NONE){
		chopspace(); if(g_Exprs[g_Pos] == '\0') return evlErr;
		evlErr = varInTable(x);  //TableCalc ̕ϐQ
	}

	if(evlErr != EE_NONE){ 
		chopspace(); if(g_Exprs[g_Pos] == '\0') return evlErr;
		if(compword(g_Exprs, "pi", g_Pos) || compword(g_Exprs, "PI", g_Pos)){ // `ϐ
			g_Pos += 2;
			*x = PI;
			evlErr = EE_NONE;
		}
	}

	if(evlErr != EE_NONE) return evlErr;

	// ܂ paren()


  g_Nest--;
  return EE_NONE;
}

/*
static ExprEvalErr_t paren(double* x){
  ExprEvalErr_t evlErr = EE_NONE;

	//chkStack();
  g_Nest++; if(g_Nest >= NESTMAX) return EE_DEEP_NESTING;


  chopspace();
  if(g_Exprs[g_Pos] == '('){
    g_Pos++;            
    evlErr = addsub(x); if(evlErr != EE_NONE) return evlErr;

    chopspace();
    if(g_Exprs[g_Pos] != ')') return EE_PAREN_NOT_MATCH; 
    g_Pos++; 
  } 
	//else {
  //  evlErr = number(x); if(evlErr != EE_NONE) return evlErr;
	//}

	if(evlErr != EE_NONE)
		evlErr = number(x); 

	if(evlErr != EE_NONE)
		evlErr = varInTable(x);  //TableCalc ̕ϐQ

	if(evlErr != EE_NONE)
		return evlErr;


  g_Nest--;
  return EE_NONE;
}
*/

static ExprEvalErr_t number(double* x){
  ExprEvalErr_t evlErr;
	unsigned int orgPos;

	//chkStack();
	g_Nest++; if(g_Nest >= NESTMAX) return EE_DEEP_NESTING;


  chopspace(); if(g_Exprs[g_Pos] == '\0') return EE_NULL_FOUND;

	orgPos = g_Pos;
  evlErr = ConvStrToDbl(x);

	//-- not a number
	if(g_Pos == orgPos || evlErr != EE_NONE)
		return EE_NOT_A_NUMBER;
	// if(g_Pos == orgPos){ 
	// 	//- constant PI
  //   if(compword(g_Exprs, "pi", g_Pos) || compword(g_Exprs, "PI", g_Pos)){
  //     g_Pos += 2;
  //     *x = PI;
	// 		g_Nest--;
  //     return EE_NONE;
  //   } 
	// 	//- refering variables
	// 	//else if(g_Exprs[g_Pos] == '$'){
  //   //  evlErr = GetVarBySymbol(x);
  //   //  if(evlErr != EE_NONE) return EE_VAR_UNDEFINED;
	// 	//  g_Nest--;
  //   //  return EE_NONE;
  //   //}
	// 	else{ return EE_NOT_A_NUMBER; }
	// 	//- TableCalc ̕ϐQ
	// 	//else{                                                                  
	// 	//	evlErr = varInTable(x);
	// 	//	g_Nest--;
  //   //  return evlErr;
	// 	//}
  // } 
	// else if(evlErr != EE_NONE){
  //   return EE_NOT_A_NUMBER;
	// }
	

	g_Nest--;
  return EE_NONE;
}


static Boolean ConvStrToUInt(double* x){
  *x = 0;
  if ((g_Exprs[g_Pos] < '0') || (g_Exprs[g_Pos] > '9')) return false;

  while((g_Exprs[g_Pos] >= '0') && (g_Exprs[g_Pos] <= '9')){
		*x = *x * 10 + (g_Exprs[g_Pos] - '0'); 
		g_Pos++;
  }

  return true;
}

ExprEvalErr_t ConvStrToDbl(double* x){
  double cSign = +1, cFraction = 0, cExponent = 0;
	Boolean isUInt = false;

  *x = 0;

  //--- sign  // (-)13.24  (-)1.23e-45  .0032
  if(g_Exprs[g_Pos] == '-'){
    cSign = -1;
    g_Pos++;
  }else if (g_Exprs[g_Pos] == '+'){
    g_Pos++;
  }

#if UseBinNum
	// HEX - 0xFF 
	if((  g_Exprs[g_Pos  ] == '0'                                ) && 
		 (  g_Exprs[g_Pos+1] == 'x'                                ) &&
		 ( (g_Exprs[g_Pos+2] >= '0' && g_Exprs[g_Pos+2] <= '9') ||
			 (g_Exprs[g_Pos+2] >= 'a' && g_Exprs[g_Pos+2] <= 'f') ||
			 (g_Exprs[g_Pos+2] >= 'A' && g_Exprs[g_Pos+2] <= 'F')    )    ){
		g_Pos += 2;
		while( (g_Exprs[g_Pos] >= '0' && g_Exprs[g_Pos] <= '9') ||
					 (g_Exprs[g_Pos] >= 'a' && g_Exprs[g_Pos] <= 'f') ||
					 (g_Exprs[g_Pos] >= 'A' && g_Exprs[g_Pos] <= 'F')    ){
			if(     g_Exprs[g_Pos] >= '0' && g_Exprs[g_Pos] <= '9'){ *x = *x * 16 + (g_Exprs[g_Pos] - '0'     ); }
			else if(g_Exprs[g_Pos] >= 'a' && g_Exprs[g_Pos] <= 'f'){ *x = *x * 16 + (g_Exprs[g_Pos] - 'a' + 10); }
			else if(g_Exprs[g_Pos] >= 'A' && g_Exprs[g_Pos] <= 'F'){ *x = *x * 16 + (g_Exprs[g_Pos] - 'A' + 10); }
			g_Pos++;
		}
		*x *= cSign;
		return EE_NONE;
	}
	// OCT - 0o77 
	else if((  g_Exprs[g_Pos  ] == '0'                                ) && 
					(  g_Exprs[g_Pos+1] == 'o'                                ) &&
					( (g_Exprs[g_Pos+2] >= '0' && g_Exprs[g_Pos+2] <= '7')    )    ){
		g_Pos += 2;
		while( (g_Exprs[g_Pos] >= '0' && g_Exprs[g_Pos] <= '7')    ){
			*x = *x * 8 + (g_Exprs[g_Pos] - '0'); 
			g_Pos++;
		}
		*x *= cSign;
		return EE_NONE;
	}
	// BIN - 0b11 
	else if((  g_Exprs[g_Pos  ] == '0'                                ) && 
					(  g_Exprs[g_Pos+1] == 'b'                                ) &&
					( (g_Exprs[g_Pos+2] >= '0' && g_Exprs[g_Pos+2] <= '1')    )    ){
		g_Pos += 2;
		while( (g_Exprs[g_Pos] >= '0' && g_Exprs[g_Pos] <= '1')    ){
			*x = *x * 2 + (g_Exprs[g_Pos] - '0'); 
			g_Pos++;
		}
		*x *= cSign;
		return EE_NONE;
	}
#endif //#if UseBinNum

  //--- integer part  // -(13).24  -(1).23e-45  .0032
  isUInt = ConvStrToUInt(x);
  
	//--- fraction part  // -13(.24)  -1(.23)e-45  .0032
  if(isUInt){
    if(g_Exprs[g_Pos] == '.'){
      g_Pos++;
      while(g_Exprs[g_Pos] == '0'){
				g_Pos++;
				cExponent += 1.;
      }
      isUInt = ConvStrToUInt(&cFraction);
      if(isUInt){
				cFraction = cFraction / (pow(10, (floor(log10(cFraction)) + 1) + cExponent));
				*x += cFraction;
      }
    }
  }
	//--- fraction part without integer part  // -13.24  -1.23e-45  (.0032)
	else{
    if(g_Exprs[g_Pos] != '.') return EE_NOT_A_NUMBER; 
    g_Pos++;
    while(g_Exprs[g_Pos] == '0'){
      g_Pos++;
      cExponent += 1.;
    }
    isUInt = ConvStrToUInt(&cFraction);
    //if(!isUInt) return EE_NOT_A_NUMBER;
    if(!isUInt){
			if(cExponent > 0) *x = 0.;
			else return EE_NOT_A_NUMBER;
		}else{
			cFraction = cFraction / (pow(10, (floor(log10(cFraction)) + 1) + cExponent));
			*x += cFraction;
		}
  }

	//--- sign
  *x *= cSign;
	
  //--- exponent part  // -13.24  -1.23(e-45)  .0032
  if((g_Exprs[g_Pos] == 'e') || (g_Exprs[g_Pos] == 'E')){
		unsigned int orgPos = g_Pos;
    g_Pos++;

    cSign = +1;
    if(     g_Exprs[g_Pos] == '-'){ g_Pos++; cSign = -1; }
		else if(g_Exprs[g_Pos] == '+'){ g_Pos++; cSign = +1; }

    isUInt = ConvStrToUInt(&cFraction);
    //DEL by HAL// if(!isUInt) return EE_NOT_A_NUMBER;
    if(!isUInt){ g_Pos = orgPos;  return EE_NONE; } // 'e''E'  1.3e1 `łȂCϐ eCeHoge ̏ꍇB̂ߌ݈ʒu߂B
    cFraction *= cSign;
    *x *= pow(10, cFraction);
  }

  return EE_NONE;
}


static ExprEvalErr_t varInTable(double* x){
	Char cVarName[MaxLen_Name+1];
	unsigned int itr, tPos = g_Pos;
	Int16 tExprNo=0, foundExprNo=-1;
	MyGlobals_t* gP = NULL;
	ExprEvalErr_t tmpErr;

	//chkStack();
	g_Nest++; if(g_Nest >= NESTMAX) return EE_DEEP_NESTING;


	//--- search var name in g_Exprs
	for(itr=0; itr<MaxLen_Name; itr++){
		tPos = g_Pos + itr;
		if( (g_Exprs[tPos] >= 'a' && g_Exprs[tPos] <= 'z') ||
				(g_Exprs[tPos] >= 'A' && g_Exprs[tPos] <= 'Z') ||
				(g_Exprs[tPos] == '_'                        )    ){ cVarName[itr] = g_Exprs[tPos];        }
		else{                                                    cVarName[itr] = '\0';          break; }
	}
	cVarName[itr] = '\0';
	if(itr < 1) return EE_NULL_FOUND; //EE_NOT_A_NUMBER;//EE_NULL_FOUND;
	
	//--- search matched var in table
	tExprNo=0;
	foundExprNo=-1;
	gP = getMyGlobals();
	
	if(gP == NULL || gP->pPage == NULL) return EE_Unexpected03;
		
	for(tExprNo=0; tExprNo < MaxDispRow; tExprNo++){
		if(compword(cVarName, gP->pPage->row[tExprNo].name, 0)){
			foundExprNo = tExprNo;
			break;
		}
	}
	//if(foundExprNo < 0 || foundExprNo >=  MaxDispRow) return EE_VAR_UNDEFINED;

	//-- y[WŎQƐ悪ꍇ
	if(foundExprNo >= 0 && foundExprNo < MaxDispRow){
		g_Pos = tPos;
		
		// ݂̐QƂĂ鐔ԍ}[NiƂŎQƌύXꂽɎXV邽߁j
		if(gP_dependsOn != NULL)
			gP_dependsOn[foundExprNo] = true;
		
		//if(!gP->cPref.gAtrb.is.AllowRecursive &&
		//	 foundExprNo == g_ExprNo) return EE_RecursiveRef; //ȎQƃG[
		//if(gP->pPage->row[foundExprNo].ansErr != EE_NONE) //QƐ悪G[̏ꍇC
		//	return gP->pPage->row[foundExprNo].ansErr;      //̃G[̂܂ܕԂB

		if(!gP->cPref.gAtrb.is.AllowRecursive){ //ʏFȎQƂG[Ƃ
			if(foundExprNo == g_ExprNo) return EE_RecursiveRef; //ȎQƃG[
			if(gP->pPage->row[foundExprNo].ansErr != EE_NONE)   //QƐ悪G[̏ꍇC
				return gP->pPage->row[foundExprNo].ansErr;        //̃G[̂܂ܕԂB
		}else{                                  //FȎQƂG[ƂȂ
			if(gP->pPage->row[foundExprNo].ansErr != EE_NONE    && 
				 gP->pPage->row[foundExprNo].ansErr != EE_NotEval   ) //QƐ悪G[̏ꍇC
				return gP->pPage->row[foundExprNo].ansErr;            //̃G[̂܂ܕԂB
		}
		
		
#if EvalVarAsExprs // ϐ̌̎]  X^bNꂪN
		tmpErr = l_EvalExprs(gP->pPage->row[foundExprNo].expr, x);
		g_Nest--;
		return tmpErr;
#else              // ȑO̕]ʂ̂܂܎gidouble ŕێĂ̂ŖȂƎvǐxIɂǂȂ񂾂Hƕς薳j
		if(gP->cPref.gAtrb.is.AllowRecursive && foundExprNo == g_ExprNo){
			*x = gP->pPage->row[foundExprNo].ansVal;
			g_Nest--;
			return EE_NONE;
		}
		else if(gP->pPage->row[foundExprNo].ansErr != EE_NotEval){
			*x = gP->pPage->row[foundExprNo].ansVal;
			g_Nest--;
			return gP->pPage->row[foundExprNo].ansErr;
		}
		else{ // 肦Ȃ͂CQƐ悪]̏ꍇ͎QƐ̌̎]
			tmpErr = l_EvalExprs(gP->pPage->row[foundExprNo].expr, x);
			g_Nest--;
			return tmpErr;
		}
#endif
		return EE_Unexpected01;
	}
	//-- y[WŎQƐ悪疳ꍇ ̃y[WT
	else if(gP->cPref.gAtrb.is.UseVarOnOtherPg){
		foundExprNo = findNameInHtcDB_ReadOnly(gP, cVarName); 

		if(foundExprNo < 0)
			return EE_VAR_UNDEFINED;
		else{
			ExprEvalErr_t tmpErr;
			//TableCalc_Record_t bufRec; //ō\̂̂̂錾ƎsG[  IɃmۂ
			TableCalc_Record_t *pRec = (TableCalc_Record_t*)MemPtrNew(sizeof(TableCalc_Record_t));

			if(gP_dependsOn != NULL)
				gP_dependsOn[OtherPageVar] = true;

			if(pRec == NULL) return EE_NoHeapMem;
			pRec->row[foundExprNo%MaxDispRow].ansVal = 0.;
			pRec->row[foundExprNo%MaxDispRow].ansErr = EE_NotEval;

			if( loadOneRecord(foundExprNo/MaxDispRow, pRec) != DB_ErrNone) tmpErr = EE_DbErr;
			else                                                           tmpErr = pRec->row[foundExprNo%MaxDispRow].ansErr;

			*x = pRec->row[foundExprNo%MaxDispRow].ansVal;

			// iy[WԎQƂ}[N
			if(gP_dependsOn != NULL && pRec->row[foundExprNo%MaxDispRow].dependsOn[OtherPageVar]){
				gP_dependsOn[NestedPages] = true;
				tmpErr = EE_NotEval;
			}

			MemPtrFree(pRec);
			g_Pos = tPos;
			g_Nest--;
			return tmpErr;
		}
	}
	else
		return EE_VAR_UNDEFINED;
	
	return EE_Unexpected02;
}


static ExprEvalErr_t l_EvalExprs(char* exprs, double* x){
  ExprEvalErr_t evlErr;
	char *orgExprs;
	unsigned int orgPos;

	//chkStack();
	//if(g_ExprNo==0){MemPtr pBgn, pEnd; (*x) = SysGetStackInfo(&pBgn, &pEnd) ? (pEnd-pBgn) : -1; return EE_NONE;} //test to get stackinfo

	g_Nest++; if(g_Nest >= NESTMAX) return EE_DEEP_NESTING;

	orgExprs = g_Exprs;  g_Exprs = exprs; 
	orgPos   = g_Pos  ;  g_Pos   = 0    ;


	evlErr = addsub(x); if(evlErr != EE_NONE) return evlErr;

	chopspace(); if(g_Exprs[g_Pos] != '\0') return EE_EXCESS_CHARACTERS;


	g_Exprs = orgExprs;
	g_Pos   = orgPos  ;

	g_Nest--;
  return EE_NONE;
}

//typedef struct { Boolean aho[10][10]; } hoge_t;
//typedef struct { Depend_t baka[10]; } piyo_t;

ExprEvalErr_t evalExprs(char* exprs, double* result, Boolean *pDependsOn, unsigned int cExprNo){
	ExprEvalErr_t evlErr = EE_NONE;

	//if(cExprNo==0){MemPtr pBgn, pEnd; (*result) = SysGetStackInfo(&pBgn, &pEnd) ? (pEnd-pBgn) : -1; return EE_NONE;} //test to get stackinfo
	//if(cExprNo==0){	(*result) = sizeof(Boolean); return EE_NONE; }
	//if(cExprNo==1){	(*result) = sizeof(Depend_t); return EE_NONE; }
	//if(cExprNo==2){	(*result) = sizeof(hoge_t); return EE_NONE; }
	//if(cExprNo==3){	(*result) = sizeof(piyo_t); return EE_NONE; }

	if(exprs == NULL || result == NULL) return EE_NullInput;

	g_Nest = 0;
	//gP_depend = pDepend;
	gP_dependsOn = pDependsOn;
	g_ExprNo = cExprNo;
	g_Exprs = NULL;
	g_Pos = 0;

	evlErr = l_EvalExprs(exprs, result);

	g_Nest = 0;
	//gP_depend = NULL;
	gP_dependsOn = NULL;
	g_ExprNo = -1;
	g_Exprs = NULL;
	g_Pos = 0;

	return evlErr;
}


Boolean compword(char* wordA, char* wordB, unsigned int cPosA){
	unsigned int itr, len = StrLen(wordB);
	
	for(itr=0; itr<len; itr++)
		if(wordA[cPosA+itr] != (char)(wordB[itr])) return false;
	
	if( (wordA[cPosA+len]) == '_'                              ) return false;
	if( (wordA[cPosA+len]) >= 'a' && (wordA[cPosA+len]) <= 'z' ) return false;
	if( (wordA[cPosA+len]) >= 'A' && (wordA[cPosA+len]) <= 'Z' ) return false;

	return true;
}


//======== ȉ͑y[W̕ϐQƂĂꍇ̏zQƃ`FbN[`
//  iy[WԎQƂ̏ꍇG[Ƃ悤ɂ̂ňȉ̃[`͂قږӖB
/*
#define MaxRecursiveNest 10

typedef struct {
	unsigned int c0ExprNo;
	unsigned int cNest;
} ChkRecursiveGlobal_t;

static ChkRecursiveGlobal_t *gPchk = NULL;

static ExprEvalErr_t chkRecursive_Depend(unsigned int cExprNo){
	ExprEvalErr_t evlErr = EE_NONE;
	char         *cExprS = NULL;
	char         *dNameS = NULL;
	unsigned int pos = 0; // index for cExpr[], as ScExprS[pos]
	unsigned int itr = 0;
	int          dExprNo = -1;


	//----- check status
	if(gPchk == NULL) return EE_Unexpected06;
	if(cExprNo == gPchk->c0ExprNo && gPchk->cNest > 0) return EE_RecursiveRef;

	gPchk->cNest++;
	//{Char cfr[32];StrPrintF(cfr," %d.%d: \0", (int)gPchk->cNest, (int)cExprNo);WinDrawChars(cfr,StrLen(cfr),1,1);}
	if(gPchk->cNest >= MaxRecursiveNest) return EE_DEEP_NESTING;


	//----- DB cExprNo ̎̕ǂݍ obt@ cExprS ɃRs[
	{ //IN: cExprNo, OUT: cExprS 
		//TableCalc_Record_t bufRec; //Ŏ̂錾ƍċAĂяoƂɗǂȂG[ł
		TableCalc_Record_t *pRec = (TableCalc_Record_t*)MemPtrNew(sizeof(TableCalc_Record_t));
		//loadOneRecord(cExprNo/MaxDispRow, &bufRec); //ŌĂԂ stack overflow C傤Ȃ̂œR[hłx
		DmOpenRef dbP = DmOpenDatabaseByTypeCreator(TableCalc_MainDBType, TableCalc_CrtrID1q, dmModeReadOnly);
		MemHandle mhRec = NULL;
		if(pRec == NULL) return EE_NoHeapMem;
		if(dbP == NULL) return EE_FailToFindVarInDB1;
		mhRec = DmGetRecord(dbP, (UInt16)cExprNo/MaxDispRow);
		if(mhRec == NULL){ DmCloseDatabase(dbP); return EE_FailToFindVarInDB2; }
		MemMove(pRec, MemHandleLock(mhRec), sizeof(TableCalc_Record_t)); // Copy Record -> Buf
		MemHandleUnlock(mhRec);
		DmReleaseRecord(dbP, (UInt16)cExprNo/MaxDispRow, false);
		DmCloseDatabase(dbP); 
		//܂ loadOneRecord() ̑
	
		cExprS = (char*)MemPtrNew(sizeof(char) * (StrLen(pRec->row[(int)cExprNo%MaxDispRow].expr)+1));
		if(cExprS == NULL) return EE_NoHeapMem;
		StrCopy(cExprS, pRec->row[(int)cExprNo%MaxDispRow].expr); 
		MemPtrFree(pRec);
	}

	//{Char cfr[64];StrPrintF(cfr," %d.%d.%d:{%s} \0", (int)gPchk->cNest, (int)cExprNo, (int)gPchk->c0ExprNo, cExprS);WinDrawChars(cfr,StrLen(cfr),1,1);}

	pos = 0;
	while(cExprS[pos] != '\0'){

		evlErr = EE_NONE;
		//----- cExprS ϐ̕ȊOXLbv
		//{Char cfr[16];StrPrintF(cfr," #1# \0" );WinDrawChars(cfr,StrLen(cfr),60,1);}
		while( cExprS[pos] != '\0' &&
					 !( cExprS[pos] == '_'                       ) &&
					 !( cExprS[pos] >= 'a' && cExprS[pos] <= 'z' ) &&
					 !( cExprS[pos] >= 'A' && cExprS[pos] <= 'Z' )    ) pos++; 
		if(cExprS[pos] == '\0') break; 
		// Q֐XLbv
		for(itr = 0; StrLen(func2Lst[itr].name) > 0 && func2Lst[itr].pfunc != NULL; itr++)
			if(compword(cExprS, (char*)func2Lst[itr].name, pos))
				pos += StrLen(func2Lst[itr].name); 
		// P֐XLbv
		for(itr = 0; StrLen(func1Lst[itr].name) > 0 && func1Lst[itr].pfunc != NULL; itr++)
			if(compword(cExprS, (char*)func1Lst[itr].name, pos))
				pos += StrLen(func1Lst[itr].name); 
		//
		// ɗ\XLbv郋[`邱 
		//
		// ϐ̕ȊOXLbv
		while( cExprS[pos] != '\0' &&
					 !( cExprS[pos] == '_'                       ) &&
					 !( cExprS[pos] >= 'a' && cExprS[pos] <= 'z' ) &&
					 !( cExprS[pos] >= 'A' && cExprS[pos] <= 'Z' )    ) pos++; 
		//{Char cfr[16];StrPrintF(cfr," #2# \0" );WinDrawChars(cfr,StrLen(cfr),60,1);}
		if(cExprS[pos] == '\0') break; 


		//----- cExprS ˑĂϐ dNameS ̕؂o(cExprNo(cExprS) depends on dExprNo(dNameS))
		if(dNameS == NULL)
			dNameS = (char*)MemPtrNew(sizeof(char) *(MaxLen_Name+1));
		if(dNameS == NULL){ evlErr = EE_NoHeapMem; break;}
		MemSet(dNameS, sizeof(char) * (MaxLen_Name+1), 0); // zero clear
		for(itr=0; itr<MaxLen_Name; itr++)
			if( ( cExprS[pos+itr] == '_'                           ) ||
					( cExprS[pos+itr] >= 'a' && cExprS[pos+itr] <= 'z' ) ||
					( cExprS[pos+itr] >= 'A' && cExprS[pos+itr] <= 'Z' )    ){ dNameS[itr] = cExprS[pos+itr]; }
			else{                                                          dNameS[itr] = '\0'; break;     }
		//{Char cfr[16];StrPrintF(cfr," #3# \0" );WinDrawChars(cfr,StrLen(cfr),60,1);}
		dNameS[itr] = '\0';
		pos += itr;
		if(itr < 1 || StrLen(dNameS) < 1)
			continue;

		//----- dNameS ̎ dExprS i[Ă DB ̏ꏊ dExprNo T
		dExprNo = -1;
		dExprNo = (int)findNameInHtcDB(dNameS);//ŌĂԂ stack overflow ?C傤Ȃ̂œR[hłx

		if(dExprNo < 0){
			//continue;
			evlErr = EE_Unexpected05; break;
		}

		//{Char cfr[64];StrPrintF(cfr,"<%d.%d=%d[%s,%s]   \0", (int)gPchk->cNest, (int)dExprNo, gPchk->c0ExprNo, dNameS, cExprS);WinDrawChars(cfr,StrLen(cfr),45,1);}
		//----- zQƂ̃`FbN
		if(    ((unsigned int)dExprNo == (unsigned int)gPchk->c0ExprNo                    ) 
				|| ((unsigned int)dExprNo == (unsigned int)        cExprNo                    ) 
		  //|| ((unsigned int)cExprNo == (unsigned int)gPchk->c0ExprNo && gPchk->cNest > 1)
			 ){
			evlErr = EE_RecursiveRef;
			break;
		}

		// recursive check for depending var(= dExprNo)
		//{Char cfr[64];StrPrintF(cfr,"<%d.%d,%d[%s,%s]   \0", (int)gPchk->cNest, (int)dExprNo, gPchk->c0ExprNo, dNameS, cExprS);WinDrawChars(cfr,StrLen(cfr),45,1);}
		evlErr = chkRecursive_Depend((unsigned int)dExprNo);
		if(evlErr != EE_NONE) break;

	}//while(cExprS[pos] != '\0')

	if(dNameS != NULL) MemPtrFree(dNameS);
	if(cExprS != NULL) MemPtrFree(cExprS);

	gPchk->cNest--;
	return evlErr;
}

ExprEvalErr_t chkRecursive(char* exprs, unsigned int c0ExprNo){
	ExprEvalErr_t evlErr = EE_NONE;
	ChkRecursiveGlobal_t cChk;

	cChk.c0ExprNo = c0ExprNo;
	cChk.cNest = 0;

	gPchk = &cChk;

	evlErr = chkRecursive_Depend(c0ExprNo);

	gPchk = NULL;

	return evlErr;
}
*/
